// Package v2 provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen version v1.8.2 DO NOT EDIT.
package v2

import (
	"bytes"
	"compress/gzip"
	"encoding/base64"
	"fmt"
	"net/http"
	"net/url"
	"path"
	"strings"

	"github.com/deepmap/oapi-codegen/pkg/runtime"
	"github.com/getkin/kin-openapi/openapi3"
	"github.com/labstack/echo/v4"
)

const (
	BearerScopes = "Bearer.Scopes"
)

// Defines values for BlueprintCustomizationsPartitioningMode.
const (
	BlueprintCustomizationsPartitioningModeAutoLvm BlueprintCustomizationsPartitioningMode = "auto-lvm"

	BlueprintCustomizationsPartitioningModeLvm BlueprintCustomizationsPartitioningMode = "lvm"

	BlueprintCustomizationsPartitioningModeRaw BlueprintCustomizationsPartitioningMode = "raw"
)

// Defines values for ComposeStatusValue.
const (
	ComposeStatusValueFailure ComposeStatusValue = "failure"

	ComposeStatusValuePending ComposeStatusValue = "pending"

	ComposeStatusValueSuccess ComposeStatusValue = "success"
)

// Defines values for CustomizationsPartitioningMode.
const (
	CustomizationsPartitioningModeAutoLvm CustomizationsPartitioningMode = "auto-lvm"

	CustomizationsPartitioningModeLvm CustomizationsPartitioningMode = "lvm"

	CustomizationsPartitioningModeRaw CustomizationsPartitioningMode = "raw"
)

// Defines values for ImageStatusValue.
const (
	ImageStatusValueBuilding ImageStatusValue = "building"

	ImageStatusValueFailure ImageStatusValue = "failure"

	ImageStatusValuePending ImageStatusValue = "pending"

	ImageStatusValueRegistering ImageStatusValue = "registering"

	ImageStatusValueSuccess ImageStatusValue = "success"

	ImageStatusValueUploading ImageStatusValue = "uploading"
)

// Defines values for ImageTypes.
const (
	ImageTypesAws ImageTypes = "aws"

	ImageTypesAwsHaRhui ImageTypes = "aws-ha-rhui"

	ImageTypesAwsRhui ImageTypes = "aws-rhui"

	ImageTypesAwsSapRhui ImageTypes = "aws-sap-rhui"

	ImageTypesAzure ImageTypes = "azure"

	ImageTypesAzureEap7Rhui ImageTypes = "azure-eap7-rhui"

	ImageTypesAzureRhui ImageTypes = "azure-rhui"

	ImageTypesAzureSapRhui ImageTypes = "azure-sap-rhui"

	ImageTypesEdgeCommit ImageTypes = "edge-commit"

	ImageTypesEdgeContainer ImageTypes = "edge-container"

	ImageTypesEdgeInstaller ImageTypes = "edge-installer"

	ImageTypesGcp ImageTypes = "gcp"

	ImageTypesGcpRhui ImageTypes = "gcp-rhui"

	ImageTypesGuestImage ImageTypes = "guest-image"

	ImageTypesImageInstaller ImageTypes = "image-installer"

	ImageTypesIotBootableContainer ImageTypes = "iot-bootable-container"

	ImageTypesIotCommit ImageTypes = "iot-commit"

	ImageTypesIotContainer ImageTypes = "iot-container"

	ImageTypesIotInstaller ImageTypes = "iot-installer"

	ImageTypesIotRawImage ImageTypes = "iot-raw-image"

	ImageTypesIotSimplifiedInstaller ImageTypes = "iot-simplified-installer"

	ImageTypesLiveInstaller ImageTypes = "live-installer"

	ImageTypesMinimalRaw ImageTypes = "minimal-raw"

	ImageTypesOci ImageTypes = "oci"

	ImageTypesVsphere ImageTypes = "vsphere"

	ImageTypesVsphereOva ImageTypes = "vsphere-ova"

	ImageTypesWsl ImageTypes = "wsl"
)

// Defines values for UploadStatusValue.
const (
	UploadStatusValueFailure UploadStatusValue = "failure"

	UploadStatusValuePending UploadStatusValue = "pending"

	UploadStatusValueRunning UploadStatusValue = "running"

	UploadStatusValueSuccess UploadStatusValue = "success"
)

// Defines values for UploadTypes.
const (
	UploadTypesAws UploadTypes = "aws"

	UploadTypesAwsS3 UploadTypes = "aws.s3"

	UploadTypesAzure UploadTypes = "azure"

	UploadTypesContainer UploadTypes = "container"

	UploadTypesGcp UploadTypes = "gcp"

	UploadTypesLocal UploadTypes = "local"

	UploadTypesOciObjectstorage UploadTypes = "oci.objectstorage"

	UploadTypesPulpOstree UploadTypes = "pulp.ostree"
)

// AWSEC2CloneCompose defines model for AWSEC2CloneCompose.
type AWSEC2CloneCompose struct {
	Region            string    `json:"region"`
	ShareWithAccounts *[]string `json:"share_with_accounts,omitempty"`
}

// AWSEC2UploadOptions defines model for AWSEC2UploadOptions.
type AWSEC2UploadOptions struct {
	Region            string   `json:"region"`
	ShareWithAccounts []string `json:"share_with_accounts"`
	SnapshotName      *string  `json:"snapshot_name,omitempty"`
}

// AWSEC2UploadStatus defines model for AWSEC2UploadStatus.
type AWSEC2UploadStatus struct {
	Ami    string `json:"ami"`
	Region string `json:"region"`
}

// AWSS3UploadOptions defines model for AWSS3UploadOptions.
type AWSS3UploadOptions struct {
	// If set to false (the default value), a long, obfuscated URL
	// is returned. Its expiration might be sooner than for other upload
	// targets.
	//
	// If set to true, a shorter URL is returned and
	// its expiration is the same as for the other upload targets.
	Public *bool  `json:"public,omitempty"`
	Region string `json:"region"`
}

// AWSS3UploadStatus defines model for AWSS3UploadStatus.
type AWSS3UploadStatus struct {
	Url string `json:"url"`
}

// AzureUploadOptions defines model for AzureUploadOptions.
type AzureUploadOptions struct {
	// Name of the uploaded image. It must be unique in the given resource group.
	// If name is omitted from the request, a random one based on a UUID is
	// generated.
	ImageName *string `json:"image_name,omitempty"`

	// Location of the provided resource_group, where the image should be uploaded and registered.
	// How to list all locations:
	// https://docs.microsoft.com/en-us/cli/azure/account?view=azure-cli-latest#az_account_list_locations'
	// If the location is not specified, it is deducted from the provided resource_group.
	Location *string `json:"location,omitempty"`

	// Name of the resource group where the image should be uploaded.
	ResourceGroup string `json:"resource_group"`

	// ID of subscription where the image should be uploaded.
	SubscriptionId string `json:"subscription_id"`

	// ID of the tenant where the image should be uploaded.
	// How to find it in the Azure Portal:
	// https://docs.microsoft.com/en-us/azure/active-directory/fundamentals/active-directory-how-to-find-tenant
	TenantId string `json:"tenant_id"`
}

// AzureUploadStatus defines model for AzureUploadStatus.
type AzureUploadStatus struct {
	ImageName string `json:"image_name"`
}

// Blueprint defines model for Blueprint.
type Blueprint struct {
	// Container images to embed into the final artfact
	Containers     *[]Container             `json:"containers,omitempty"`
	Customizations *BlueprintCustomizations `json:"customizations,omitempty"`
	Description    *string                  `json:"description,omitempty"`

	// The distribution to use for the compose. If left empty the host
	// distro will be used.
	Distro *string `json:"distro,omitempty"`

	// Package groups to be installed
	Groups *[]PackageGroup `json:"groups,omitempty"`

	// An alias for packages, retained for backwards compatability
	Modules *[]Package `json:"modules,omitempty"`
	Name    string     `json:"name"`

	// Packages to be installed
	Packages *[]Package `json:"packages,omitempty"`

	// A semver version number
	Version *string `json:"version,omitempty"`
}

// BlueprintCustomizations defines model for BlueprintCustomizations.
type BlueprintCustomizations struct {
	// Directories to create in the final artifact
	Directories *[]Directory `json:"directories,omitempty"`

	// FIDO device onboard configuration
	Fdo *FDO `json:"fdo,omitempty"`

	// Files to create in the final artifact
	Files *[]BlueprintFile `json:"files,omitempty"`

	// List of filesystem mountpoints to create
	Filesystem *[]BlueprintFilesystem `json:"filesystem,omitempty"`

	// Enable FIPS mode
	Fips *bool `json:"fips,omitempty"`

	// Firewalld configuration
	Firewall *BlueprintFirewall `json:"firewall,omitempty"`

	// List of groups to create
	Group *[]Group `json:"group,omitempty"`

	// Configures the hostname
	Hostname *string `json:"hostname,omitempty"`

	// Ignition configuration
	Ignition *Ignition `json:"ignition,omitempty"`

	// Name of the installation device, currently only useful for the edge-simplified-installer type
	InstallationDevice *string    `json:"installation_device,omitempty"`
	Installer          *Installer `json:"installer,omitempty"`
	Kernel             *Kernel    `json:"kernel,omitempty"`

	// Locale configuration
	Locale   *Locale            `json:"locale,omitempty"`
	Openscap *BlueprintOpenSCAP `json:"openscap,omitempty"`

	// Select how the disk image will be partitioned. 'auto-lvm' will use raw unless
	// there are one or more mountpoints in which case it will use LVM. 'lvm' always
	// uses LVM, even when there are no extra mountpoints. 'raw' uses raw partitions
	// even when there are one or more mountpoints.
	PartitioningMode *BlueprintCustomizationsPartitioningMode `json:"partitioning_mode,omitempty"`

	// Repositories to write to /etc/yum.repos.d/ in the final image. Note
	// that these are not used at build time.
	Repositories *[]BlueprintRepository `json:"repositories,omitempty"`
	Rhsm         *RHSMCustomization     `json:"rhsm,omitempty"`
	Rpm          *RPMCustomization      `json:"rpm,omitempty"`
	Services     *Services              `json:"services,omitempty"`

	// List of ssh keys
	Sshkey *[]SSHKey `json:"sshkey,omitempty"`

	// Timezone configuration
	Timezone *Timezone `json:"timezone,omitempty"`

	// List of users to create
	User *[]BlueprintUser `json:"user,omitempty"`
}

// Select how the disk image will be partitioned. 'auto-lvm' will use raw unless
// there are one or more mountpoints in which case it will use LVM. 'lvm' always
// uses LVM, even when there are no extra mountpoints. 'raw' uses raw partitions
// even when there are one or more mountpoints.
type BlueprintCustomizationsPartitioningMode string

// A custom file to create in the final artifact.
type BlueprintFile struct {
	// Contents of the file as plain text
	Data *string `json:"data,omitempty"`

	// Group of the file as a gid or a group name
	Group *interface{} `json:"group,omitempty"`

	// Permissions string for the file in octal format
	Mode *string `json:"mode,omitempty"`

	// Path to the file
	Path string `json:"path"`

	// Owner of the file as a uid or a user name
	User *interface{} `json:"user,omitempty"`
}

// BlueprintFilesystem defines model for BlueprintFilesystem.
type BlueprintFilesystem struct {
	// size of the filesystem in bytes
	Minsize    uint64 `json:"minsize"`
	Mountpoint string `json:"mountpoint"`
}

// Firewalld configuration
type BlueprintFirewall struct {
	// List of ports (or port ranges) and protocols to open
	Ports *[]string `json:"ports,omitempty"`

	// Firewalld services to enable or disable
	Services *FirewallServices `json:"services,omitempty"`
	Zones    *[]FirewallZones  `json:"zones,omitempty"`
}

// BlueprintOpenSCAP defines model for BlueprintOpenSCAP.
type BlueprintOpenSCAP struct {
	Datastream    *string                `json:"datastream,omitempty"`
	JsonTailoring *OpenSCAPJSONTailoring `json:"json_tailoring,omitempty"`

	// Puts a specified policy ID in the RHSM facts, so that any instances registered to
	// insights will be automatically connected to the compliance policy in the console.
	PolicyId  *string            `json:"policy_id,omitempty"`
	ProfileId string             `json:"profile_id"`
	Tailoring *OpenSCAPTailoring `json:"tailoring,omitempty"`
}

// BlueprintRepository defines model for BlueprintRepository.
type BlueprintRepository struct {
	Baseurls   *[]string `json:"baseurls,omitempty"`
	Enabled    *bool     `json:"enabled,omitempty"`
	Filename   *string   `json:"filename,omitempty"`
	Gpgcheck   *bool     `json:"gpgcheck,omitempty"`
	Gpgkeys    *[]string `json:"gpgkeys,omitempty"`
	Id         string    `json:"id"`
	Metalink   *string   `json:"metalink,omitempty"`
	Mirrorlist *string   `json:"mirrorlist,omitempty"`

	// Disables modularity filtering for this repository.
	ModuleHotfixes *bool   `json:"module_hotfixes,omitempty"`
	Name           *string `json:"name,omitempty"`
	Priority       *int    `json:"priority,omitempty"`
	RepoGpgcheck   *bool   `json:"repo_gpgcheck,omitempty"`
	Sslverify      *bool   `json:"sslverify,omitempty"`
}

// BlueprintUser defines model for BlueprintUser.
type BlueprintUser struct {
	Description *string `json:"description,omitempty"`

	// Group id to use instead of the default
	Gid *int `json:"gid,omitempty"`

	// A list of additional groups to add the user to
	Groups *[]string `json:"groups,omitempty"`

	// The user's home directory
	Home *string `json:"home,omitempty"`

	// ssh public key
	Key  *string `json:"key,omitempty"`
	Name string  `json:"name"`

	// If the password starts with $6$, $5$, or $2b$ it will be stored as
	// an encrypted password. Otherwise it will be treated as a plain text
	// password.
	Password *string `json:"password,omitempty"`

	// Login shell to use
	Shell *string `json:"shell,omitempty"`

	// User id to use instead of the default
	Uid *int `json:"uid,omitempty"`
}

// CloneComposeBody defines model for CloneComposeBody.
type CloneComposeBody interface{}

// CloneComposeResponse defines model for CloneComposeResponse.
type CloneComposeResponse struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Id string `json:"id"`
}

// CloneStatus defines model for CloneStatus.
type CloneStatus struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded struct due to allOf(#/components/schemas/UploadStatus)
	UploadStatus `yaml:",inline"`
}

// ComposeDeleteStatus defines model for ComposeDeleteStatus.
type ComposeDeleteStatus ObjectReference

// ComposeId defines model for ComposeId.
type ComposeId struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Id string `json:"id"`
}

// ComposeList defines model for ComposeList.
type ComposeList struct {
	// Embedded struct due to allOf(#/components/schemas/List)
	List `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Items []ComposeStatus `json:"items"`
}

// ComposeLogs defines model for ComposeLogs.
type ComposeLogs struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	ImageBuilds []interface{} `json:"image_builds"`
	Koji        *KojiLogs     `json:"koji,omitempty"`
}

// ComposeManifests defines model for ComposeManifests.
type ComposeManifests struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Manifests []interface{} `json:"manifests"`
}

// ComposeMetadata defines model for ComposeMetadata.
type ComposeMetadata struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	// ID (hash) of the built commit
	OstreeCommit *string `json:"ostree_commit,omitempty"`

	// Package list including NEVRA
	Packages *[]PackageMetadata `json:"packages,omitempty"`
}

// ComposeRequest defines model for ComposeRequest.
type ComposeRequest struct {
	Blueprint      *Blueprint      `json:"blueprint,omitempty"`
	Customizations *Customizations `json:"customizations,omitempty"`
	Distribution   string          `json:"distribution"`
	ImageRequest   *ImageRequest   `json:"image_request,omitempty"`
	ImageRequests  *[]ImageRequest `json:"image_requests,omitempty"`
	Koji           *Koji           `json:"koji,omitempty"`
}

// ComposeStatus defines model for ComposeStatus.
type ComposeStatus struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	ImageStatus   ImageStatus        `json:"image_status"`
	ImageStatuses *[]ImageStatus     `json:"image_statuses,omitempty"`
	KojiStatus    *KojiStatus        `json:"koji_status,omitempty"`
	Status        ComposeStatusValue `json:"status"`
}

// ComposeStatusError defines model for ComposeStatusError.
type ComposeStatusError struct {
	Details *interface{} `json:"details,omitempty"`
	Id      int          `json:"id"`
	Reason  string       `json:"reason"`
}

// ComposeStatusValue defines model for ComposeStatusValue.
type ComposeStatusValue string

// Container defines model for Container.
type Container struct {
	// Name to use for the container from the image
	Name *string `json:"name,omitempty"`

	// Reference to the container to embed
	Source string `json:"source"`

	// Control TLS verifification
	TlsVerify *bool `json:"tls_verify,omitempty"`
}

// ContainerUploadOptions defines model for ContainerUploadOptions.
type ContainerUploadOptions struct {
	// Name for the created container image
	Name *string `json:"name,omitempty"`

	// Tag for the created container image
	Tag *string `json:"tag,omitempty"`
}

// ContainerUploadStatus defines model for ContainerUploadStatus.
type ContainerUploadStatus struct {
	// Digest of the manifest of the uploaded container on the registry
	Digest string `json:"digest"`

	// FQDN of the uploaded image
	Url string `json:"url"`
}

// CustomRepository defines model for CustomRepository.
type CustomRepository struct {
	Baseurl        *[]string `json:"baseurl,omitempty"`
	CheckGpg       *bool     `json:"check_gpg,omitempty"`
	CheckRepoGpg   *bool     `json:"check_repo_gpg,omitempty"`
	Enabled        *bool     `json:"enabled,omitempty"`
	Filename       *string   `json:"filename,omitempty"`
	Gpgkey         *[]string `json:"gpgkey,omitempty"`
	Id             string    `json:"id"`
	Metalink       *string   `json:"metalink,omitempty"`
	Mirrorlist     *string   `json:"mirrorlist,omitempty"`
	ModuleHotfixes *bool     `json:"module_hotfixes,omitempty"`
	Name           *string   `json:"name,omitempty"`
	Priority       *int      `json:"priority,omitempty"`
	SslVerify      *bool     `json:"ssl_verify,omitempty"`
}

// Customizations defines model for Customizations.
type Customizations struct {
	Containers *[]Container `json:"containers,omitempty"`

	// Extra repositories for packages specified in customizations. These
	// repositories will be used to depsolve and retrieve packages. Additionally,
	// these packages will be saved and imported to the `/etc/yum.repos.d/` directory
	// on the image
	CustomRepositories *[]CustomRepository `json:"custom_repositories,omitempty"`
	Directories        *[]Directory        `json:"directories,omitempty"`

	// FIDO device onboard configuration
	Fdo        *FDO          `json:"fdo,omitempty"`
	Files      *[]File       `json:"files,omitempty"`
	Filesystem *[]Filesystem `json:"filesystem,omitempty"`

	// System FIPS mode setup
	Fips *FIPS `json:"fips,omitempty"`

	// Firewalld configuration
	Firewall *FirewallCustomization `json:"firewall,omitempty"`

	// List of groups to create
	Groups *[]Group `json:"groups,omitempty"`

	// Configures the hostname
	Hostname *string `json:"hostname,omitempty"`

	// Ignition configuration
	Ignition *Ignition `json:"ignition,omitempty"`

	// Name of the installation device, currently only useful for the edge-simplified-installer type
	InstallationDevice *string    `json:"installation_device,omitempty"`
	Installer          *Installer `json:"installer,omitempty"`
	Kernel             *Kernel    `json:"kernel,omitempty"`

	// Locale configuration
	Locale   *Locale   `json:"locale,omitempty"`
	Openscap *OpenSCAP `json:"openscap,omitempty"`
	Packages *[]string `json:"packages,omitempty"`

	// Select how the disk image will be partitioned. 'auto-lvm' will use raw unless
	// there are one or more mountpoints in which case it will use LVM. 'lvm' always
	// uses LVM, even when there are no extra mountpoints. 'raw' uses raw partitions
	// even when there are one or more mountpoints.
	PartitioningMode *CustomizationsPartitioningMode `json:"partitioning_mode,omitempty"`

	// Extra repositories for packages specified in customizations. These
	// repositories will only be used to depsolve and retrieve packages
	// for the OS itself (they will not be available for the build root or
	// any other part of the build process). The package_sets field for these
	// repositories is ignored.
	PayloadRepositories *[]Repository      `json:"payload_repositories,omitempty"`
	Rhsm                *RHSMCustomization `json:"rhsm,omitempty"`
	Rpm                 *RPMCustomization  `json:"rpm,omitempty"`
	Services            *Services          `json:"services,omitempty"`
	Subscription        *Subscription      `json:"subscription,omitempty"`

	// Timezone configuration
	Timezone *Timezone `json:"timezone,omitempty"`
	Users    *[]User   `json:"users,omitempty"`
}

// Select how the disk image will be partitioned. 'auto-lvm' will use raw unless
// there are one or more mountpoints in which case it will use LVM. 'lvm' always
// uses LVM, even when there are no extra mountpoints. 'raw' uses raw partitions
// even when there are one or more mountpoints.
type CustomizationsPartitioningMode string

// DNFPluginConfig defines model for DNFPluginConfig.
type DNFPluginConfig struct {
	Enabled *bool `json:"enabled,omitempty"`
}

// A custom directory to create in the final artifact.
type Directory struct {
	// Ensure that the parent directories exist
	EnsureParents *bool `json:"ensure_parents,omitempty"`

	// Group of the directory as a group name or a gid
	Group *interface{} `json:"group,omitempty"`

	// Permissions string for the directory in octal format
	Mode *string `json:"mode,omitempty"`

	// Path to the directory
	Path string `json:"path"`

	// Owner of the directory as a user name or a uid
	User *interface{} `json:"user,omitempty"`
}

// Error defines model for Error.
type Error struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Code        string       `json:"code"`
	Details     *interface{} `json:"details,omitempty"`
	OperationId string       `json:"operation_id"`
	Reason      string       `json:"reason"`
}

// ErrorList defines model for ErrorList.
type ErrorList struct {
	// Embedded struct due to allOf(#/components/schemas/List)
	List `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Items []Error `json:"items"`
}

// FIDO device onboard configuration
type FDO struct {
	DiMfgStringTypeMacIface *string `json:"di_mfg_string_type_mac_iface,omitempty"`
	DiunPubKeyHash          *string `json:"diun_pub_key_hash,omitempty"`
	DiunPubKeyInsecure      *string `json:"diun_pub_key_insecure,omitempty"`
	DiunPubKeyRootCerts     *string `json:"diun_pub_key_root_certs,omitempty"`
	ManufacturingServerUrl  *string `json:"manufacturing_server_url,omitempty"`
}

// System FIPS mode setup
type FIPS struct {
	// Enables the system FIPS mode
	Enabled *bool `json:"enabled,omitempty"`
}

// A custom file to create in the final artifact.
type File struct {
	// Contents of the file as plain text
	Data *string `json:"data,omitempty"`

	// Ensure that the parent directories exist
	EnsureParents *bool `json:"ensure_parents,omitempty"`

	// Group of the file as a gid or a group name
	Group *interface{} `json:"group,omitempty"`

	// Permissions string for the file in octal format
	Mode *string `json:"mode,omitempty"`

	// Path to the file
	Path string `json:"path"`

	// Owner of the file as a uid or a user name
	User *interface{} `json:"user,omitempty"`
}

// Filesystem defines model for Filesystem.
type Filesystem struct {
	// size of the filesystem in bytes
	MinSize    uint64 `json:"min_size"`
	Mountpoint string `json:"mountpoint"`
}

// Firewalld configuration
type FirewallCustomization struct {
	// List of ports (or port ranges) and protocols to open
	Ports *[]string `json:"ports,omitempty"`

	// Firewalld services to enable or disable
	Services *FirewallServices `json:"services,omitempty"`
}

// Firewalld services to enable or disable
type FirewallServices struct {
	// List of services to disable
	Disabled *[]string `json:"disabled,omitempty"`

	// List of services to enable
	Enabled *[]string `json:"enabled,omitempty"`
}

// Bind a list of network sources to a zone to restrict traffic from
// those sources based on the settings of the zone.
type FirewallZones struct {
	// name of the zone, if left empty the sources will apply to
	// the default zone.
	Name *string `json:"name,omitempty"`

	// List of sources for the zone
	Sources *[]string `json:"sources,omitempty"`
}

// GCPUploadOptions defines model for GCPUploadOptions.
type GCPUploadOptions struct {
	// Name of an existing STANDARD Storage class Bucket.
	Bucket *string `json:"bucket,omitempty"`

	// The name to use for the imported and shared Compute Engine image.
	// The image name must be unique within the GCP project, which is used
	// for the OS image upload and import. If not specified a random
	// 'composer-api-<uuid>' string is used as the image name.
	ImageName *string `json:"image_name,omitempty"`

	// The GCP region where the OS image will be imported to and shared from.
	// The value must be a valid GCP location. See https://cloud.google.com/storage/docs/locations.
	// If not specified, the multi-region location closest to the source
	// (source Storage Bucket location) is chosen automatically.
	Region string `json:"region"`

	// List of valid Google accounts to share the imported Compute Engine image with.
	// Each string must contain a specifier of the account type. Valid formats are:
	//   - 'user:{emailid}': An email address that represents a specific
	//     Google account. For example, 'alice@example.com'.
	//   - 'serviceAccount:{emailid}': An email address that represents a
	//     service account. For example, 'my-other-app@appspot.gserviceaccount.com'.
	//   - 'group:{emailid}': An email address that represents a Google group.
	//     For example, 'admins@example.com'.
	//   - 'domain:{domain}': The G Suite domain (primary) that represents all
	//     the users of that domain. For example, 'google.com' or 'example.com'.
	// If not specified, the imported Compute Engine image is not shared with any
	// account.
	ShareWithAccounts *[]string `json:"share_with_accounts,omitempty"`
}

// GCPUploadStatus defines model for GCPUploadStatus.
type GCPUploadStatus struct {
	ImageName string `json:"image_name"`
	ProjectId string `json:"project_id"`
}

// Group defines model for Group.
type Group struct {
	// Group id of the group to create (optional)
	Gid *int `json:"gid,omitempty"`

	// Name of the group to create
	Name string `json:"name"`
}

// Ignition configuration
type Ignition struct {
	Embedded  *IgnitionEmbedded  `json:"embedded,omitempty"`
	Firstboot *IgnitionFirstboot `json:"firstboot,omitempty"`
}

// IgnitionEmbedded defines model for IgnitionEmbedded.
type IgnitionEmbedded struct {
	Config string `json:"config"`
}

// IgnitionFirstboot defines model for IgnitionFirstboot.
type IgnitionFirstboot struct {
	// Provisioning URL
	Url string `json:"url"`
}

// ImageRequest defines model for ImageRequest.
type ImageRequest struct {
	Architecture string       `json:"architecture"`
	ImageType    ImageTypes   `json:"image_type"`
	Ostree       *OSTree      `json:"ostree,omitempty"`
	Repositories []Repository `json:"repositories"`

	// Size of image, in bytes. When set to 0 the image size is a minimum
	// defined by the image type.
	Size *uint64 `json:"size,omitempty"`

	// Options for a given upload destination.
	// This should really be oneOf but AWSS3UploadOptions is a subset of
	// AWSEC2UploadOptions. This means that all AWSEC2UploadOptions objects
	// are also valid AWSS3UploadOptionas objects which violates the oneOf
	// rules. Therefore, we have to use anyOf here but be aware that it isn't
	// possible to mix and match more schemas together.
	UploadOptions *UploadOptions `json:"upload_options,omitempty"`

	// The type and options for multiple upload targets. Each item defines
	// a separate upload destination with its own options. Multiple
	// different targets as well as multiple targets of the same kind are
	// supported.
	UploadTargets *[]UploadTarget `json:"upload_targets,omitempty"`
}

// ImageStatus defines model for ImageStatus.
type ImageStatus struct {
	Error          *ComposeStatusError `json:"error,omitempty"`
	Status         ImageStatusValue    `json:"status"`
	UploadStatus   *UploadStatus       `json:"upload_status,omitempty"`
	UploadStatuses *[]UploadStatus     `json:"upload_statuses,omitempty"`
}

// ImageStatusValue defines model for ImageStatusValue.
type ImageStatusValue string

// ImageTypes defines model for ImageTypes.
type ImageTypes string

// ImportKeys defines model for ImportKeys.
type ImportKeys struct {
	Files *[]string `json:"files,omitempty"`
}

// Installer defines model for Installer.
type Installer struct {
	SudoNopasswd *[]string `json:"sudo-nopasswd,omitempty"`
	Unattended   *bool     `json:"unattended,omitempty"`
}

// Kernel defines model for Kernel.
type Kernel struct {
	// Appends arguments to the bootloader kernel command line
	Append *string `json:"append,omitempty"`

	// Name of the kernel to use
	Name *string `json:"name,omitempty"`
}

// Koji defines model for Koji.
type Koji struct {
	Name    string `json:"name"`
	Release string `json:"release"`
	Server  string `json:"server"`
	TaskId  int    `json:"task_id"`
	Version string `json:"version"`
}

// KojiLogs defines model for KojiLogs.
type KojiLogs struct {
	Import interface{} `json:"import"`
	Init   interface{} `json:"init"`
}

// KojiStatus defines model for KojiStatus.
type KojiStatus struct {
	BuildId *int `json:"build_id,omitempty"`
}

// List defines model for List.
type List struct {
	Kind  string `json:"kind"`
	Page  int    `json:"page"`
	Size  int    `json:"size"`
	Total int    `json:"total"`
}

// LocalUploadOptions defines model for LocalUploadOptions.
type LocalUploadOptions struct {
	// This is used in combination with the OSBUILD_LOCALSAVE environmental
	// variable on the server to enable saving the compose locally. This
	// is for development use only, and is not available to users.
	LocalSave bool `json:"local_save"`
}

// Locale configuration
type Locale struct {
	// Sets the keyboard layout
	Keyboard *string `json:"keyboard,omitempty"`

	// List of locales to be installed, the first one becomes primary, subsequent ones are secondary
	Languages *[]string `json:"languages,omitempty"`
}

// OCIUploadOptions defines model for OCIUploadOptions.
type OCIUploadOptions map[string]interface{}

// OCIUploadStatus defines model for OCIUploadStatus.
type OCIUploadStatus struct {
	Url string `json:"url"`
}

// OSTree defines model for OSTree.
type OSTree struct {
	// A URL which, if set, is used for fetching content. Implies that `url` is set as well,
	// which will be used for metadata only.
	Contenturl *string `json:"contenturl,omitempty"`

	// Can be either a commit (example: 02604b2da6e954bd34b8b82a835e5a77d2b60ffa), or a branch-like reference (example: rhel/8/x86_64/edge)
	Parent *string `json:"parent,omitempty"`
	Ref    *string `json:"ref,omitempty"`

	// Determines whether a valid subscription manager (candlepin) identity is required to
	// access this repository. Consumer certificates will be used as client certificates when
	// fetching metadata and content.
	Rhsm *bool   `json:"rhsm,omitempty"`
	Url  *string `json:"url,omitempty"`
}

// ObjectReference defines model for ObjectReference.
type ObjectReference struct {
	Href string `json:"href"`
	Id   string `json:"id"`
	Kind string `json:"kind"`
}

// OpenSCAP defines model for OpenSCAP.
type OpenSCAP struct {
	JsonTailoring *OpenSCAPJSONTailoring `json:"json_tailoring,omitempty"`

	// Puts a specified policy ID in the RHSM facts, so that any instances registered to
	// insights will be automatically connected to the compliance policy in the console.
	PolicyId  *string            `json:"policy_id,omitempty"`
	ProfileId string             `json:"profile_id"`
	Tailoring *OpenSCAPTailoring `json:"tailoring,omitempty"`
}

// OpenSCAPJSONTailoring defines model for OpenSCAPJSONTailoring.
type OpenSCAPJSONTailoring struct {
	Filepath  string `json:"filepath"`
	ProfileId string `json:"profile_id"`
}

// OpenSCAPTailoring defines model for OpenSCAPTailoring.
type OpenSCAPTailoring struct {
	Selected   *[]string `json:"selected,omitempty"`
	Unselected *[]string `json:"unselected,omitempty"`
}

// Package defines model for Package.
type Package struct {
	// Name of the package to install. File globbing is supported,
	// eg. 'openssh-*'
	Name string `json:"name"`

	// Optional version of the package to install. If left blank the
	// latest available version will be used. Wildcards are supported
	// eg. '4.11.*'
	Version *string `json:"version,omitempty"`
}

// PackageGroup defines model for PackageGroup.
type PackageGroup struct {
	// Package group name
	Name string `json:"name"`
}

// PackageMetadata defines model for PackageMetadata.
type PackageMetadata struct {
	Arch      string  `json:"arch"`
	Epoch     *string `json:"epoch,omitempty"`
	Name      string  `json:"name"`
	Release   string  `json:"release"`
	Sigmd5    string  `json:"sigmd5"`
	Signature *string `json:"signature,omitempty"`
	Type      string  `json:"type"`
	Version   string  `json:"version"`
}

// PulpOSTreeUploadOptions defines model for PulpOSTreeUploadOptions.
type PulpOSTreeUploadOptions struct {
	// Basepath for distributing the repository
	Basepath string `json:"basepath"`

	// Repository to import the ostree commit to
	Repository    *string `json:"repository,omitempty"`
	ServerAddress *string `json:"server_address,omitempty"`
}

// PulpOSTreeUploadStatus defines model for PulpOSTreeUploadStatus.
type PulpOSTreeUploadStatus struct {
	RepoUrl string `json:"repo_url"`
}

// RHSMConfig defines model for RHSMConfig.
type RHSMConfig struct {
	DnfPlugins          *SubManDNFPluginsConfig `json:"dnf_plugins,omitempty"`
	SubscriptionManager *SubManConfig           `json:"subscription_manager,omitempty"`
}

// RHSMCustomization defines model for RHSMCustomization.
type RHSMCustomization struct {
	Config *RHSMConfig `json:"config,omitempty"`
}

// RPMCustomization defines model for RPMCustomization.
type RPMCustomization struct {
	ImportKeys *ImportKeys `json:"import_keys,omitempty"`
}

// Repository configuration.
// At least one of the 'baseurl', 'mirrorlist', 'metalink' properties must
// be specified. If more of them are specified, the order of precedence is
// the same as listed above.
type Repository struct {
	Baseurl  *string `json:"baseurl,omitempty"`
	CheckGpg *bool   `json:"check_gpg,omitempty"`

	// Enables gpg verification of the repository metadata
	CheckRepoGpg *bool `json:"check_repo_gpg,omitempty"`

	// GPG key used to sign packages in this repository.
	Gpgkey     *string `json:"gpgkey,omitempty"`
	IgnoreSsl  *bool   `json:"ignore_ssl,omitempty"`
	Metalink   *string `json:"metalink,omitempty"`
	Mirrorlist *string `json:"mirrorlist,omitempty"`

	// Disables modularity filtering for this repository.
	ModuleHotfixes *bool `json:"module_hotfixes,omitempty"`

	// Naming package sets for a repository assigns it to a specific part
	// (pipeline) of the build process.
	PackageSets *[]string `json:"package_sets,omitempty"`

	// Determines whether a valid subscription is required to access this repository.
	Rhsm *bool `json:"rhsm,omitempty"`
}

// SSHKey defines model for SSHKey.
type SSHKey struct {
	// Adds the key to the user's authorized_keys file
	Key string `json:"key"`

	// User to configure the ssh key for
	User string `json:"user"`
}

// Services defines model for Services.
type Services struct {
	// List of services to disable by default
	Disabled *[]string `json:"disabled,omitempty"`

	// List of services to enable by default
	Enabled *[]string `json:"enabled,omitempty"`

	// List of services to mask by default
	Masked *[]string `json:"masked,omitempty"`
}

// SubManConfig defines model for SubManConfig.
type SubManConfig struct {
	Rhsm      *SubManRHSMConfig      `json:"rhsm,omitempty"`
	Rhsmcertd *SubManRHSMCertdConfig `json:"rhsmcertd,omitempty"`
}

// SubManDNFPluginsConfig defines model for SubManDNFPluginsConfig.
type SubManDNFPluginsConfig struct {
	ProductId           *DNFPluginConfig `json:"product_id,omitempty"`
	SubscriptionManager *DNFPluginConfig `json:"subscription_manager,omitempty"`
}

// SubManRHSMCertdConfig defines model for SubManRHSMCertdConfig.
type SubManRHSMCertdConfig struct {
	AutoRegistration *bool `json:"auto_registration,omitempty"`
}

// SubManRHSMConfig defines model for SubManRHSMConfig.
type SubManRHSMConfig struct {
	ManageRepos *bool `json:"manage_repos,omitempty"`
}

// Subscription defines model for Subscription.
type Subscription struct {
	ActivationKey string `json:"activation_key"`
	BaseUrl       string `json:"base_url"`
	Insights      bool   `json:"insights"`
	Organization  string `json:"organization"`

	// Optional flag to use rhc to register the system, which also always enables Insights.
	Rhc       *bool  `json:"rhc,omitempty"`
	ServerUrl string `json:"server_url"`
}

// Timezone configuration
type Timezone struct {
	// List of ntp servers
	Ntpservers *[]string `json:"ntpservers,omitempty"`

	// Name of the timezone, defaults to UTC
	Timezone *string `json:"timezone,omitempty"`
}

// Options for a given upload destination.
// This should really be oneOf but AWSS3UploadOptions is a subset of
// AWSEC2UploadOptions. This means that all AWSEC2UploadOptions objects
// are also valid AWSS3UploadOptionas objects which violates the oneOf
// rules. Therefore, we have to use anyOf here but be aware that it isn't
// possible to mix and match more schemas together.
type UploadOptions interface{}

// UploadStatus defines model for UploadStatus.
type UploadStatus struct {
	Options interface{}       `json:"options"`
	Status  UploadStatusValue `json:"status"`
	Type    UploadTypes       `json:"type"`
}

// UploadStatusValue defines model for UploadStatusValue.
type UploadStatusValue string

// UploadTarget defines model for UploadTarget.
type UploadTarget struct {
	Type UploadTypes `json:"type"`

	// Options for a given upload destination.
	// This should really be oneOf but AWSS3UploadOptions is a subset of
	// AWSEC2UploadOptions. This means that all AWSEC2UploadOptions objects
	// are also valid AWSS3UploadOptionas objects which violates the oneOf
	// rules. Therefore, we have to use anyOf here but be aware that it isn't
	// possible to mix and match more schemas together.
	UploadOptions UploadOptions `json:"upload_options"`
}

// UploadTypes defines model for UploadTypes.
type UploadTypes string

// User defines model for User.
type User struct {
	Groups *[]string `json:"groups,omitempty"`
	Key    *string   `json:"key,omitempty"`
	Name   string    `json:"name"`

	// If the password starts with $6$, $5$, or $2b$ it will be stored as
	// an encrypted password. Otherwise it will be treated as a plain text
	// password.
	Password *string `json:"password,omitempty"`
}

// Page defines model for page.
type Page string

// Size defines model for size.
type Size string

// PostComposeJSONBody defines parameters for PostCompose.
type PostComposeJSONBody ComposeRequest

// PostCloneComposeJSONBody defines parameters for PostCloneCompose.
type PostCloneComposeJSONBody CloneComposeBody

// GetErrorListParams defines parameters for GetErrorList.
type GetErrorListParams struct {
	// Page index
	Page *Page `json:"page,omitempty"`

	// Number of items in each page
	Size *Size `json:"size,omitempty"`
}

// PostComposeJSONRequestBody defines body for PostCompose for application/json ContentType.
type PostComposeJSONRequestBody PostComposeJSONBody

// PostCloneComposeJSONRequestBody defines body for PostCloneCompose for application/json ContentType.
type PostCloneComposeJSONRequestBody PostCloneComposeJSONBody

// ServerInterface represents all server handlers.
type ServerInterface interface {
	// The status of a cloned compose
	// (GET /clones/{id})
	GetCloneStatus(ctx echo.Context, id string) error
	// Create compose
	// (POST /compose)
	PostCompose(ctx echo.Context) error
	// The list of composes
	// (GET /composes/)
	GetComposeList(ctx echo.Context) error
	// Delete a compose
	// (DELETE /composes/delete/{id})
	DeleteCompose(ctx echo.Context, id string) error
	// The status of a compose
	// (GET /composes/{id})
	GetComposeStatus(ctx echo.Context, id string) error
	// Clone an existing compose
	// (POST /composes/{id}/clone)
	PostCloneCompose(ctx echo.Context, id string) error
	// Get logs for a compose.
	// (GET /composes/{id}/logs)
	GetComposeLogs(ctx echo.Context, id string) error
	// Get the manifests for a compose.
	// (GET /composes/{id}/manifests)
	GetComposeManifests(ctx echo.Context, id string) error
	// Get the metadata for a compose.
	// (GET /composes/{id}/metadata)
	GetComposeMetadata(ctx echo.Context, id string) error
	// Get a list of all possible errors
	// (GET /errors)
	GetErrorList(ctx echo.Context, params GetErrorListParams) error
	// Get error description
	// (GET /errors/{id})
	GetError(ctx echo.Context, id string) error
	// Get the openapi spec in json format
	// (GET /openapi)
	GetOpenapi(ctx echo.Context) error
}

// ServerInterfaceWrapper converts echo contexts to parameters.
type ServerInterfaceWrapper struct {
	Handler ServerInterface
}

// GetCloneStatus converts echo context to params.
func (w *ServerInterfaceWrapper) GetCloneStatus(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetCloneStatus(ctx, id)
	return err
}

// PostCompose converts echo context to params.
func (w *ServerInterfaceWrapper) PostCompose(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PostCompose(ctx)
	return err
}

// GetComposeList converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeList(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeList(ctx)
	return err
}

// DeleteCompose converts echo context to params.
func (w *ServerInterfaceWrapper) DeleteCompose(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.DeleteCompose(ctx, id)
	return err
}

// GetComposeStatus converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeStatus(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeStatus(ctx, id)
	return err
}

// PostCloneCompose converts echo context to params.
func (w *ServerInterfaceWrapper) PostCloneCompose(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PostCloneCompose(ctx, id)
	return err
}

// GetComposeLogs converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeLogs(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeLogs(ctx, id)
	return err
}

// GetComposeManifests converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeManifests(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeManifests(ctx, id)
	return err
}

// GetComposeMetadata converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeMetadata(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeMetadata(ctx, id)
	return err
}

// GetErrorList converts echo context to params.
func (w *ServerInterfaceWrapper) GetErrorList(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{""})

	// Parameter object where we will unmarshal all parameters from the context
	var params GetErrorListParams
	// ------------- Optional query parameter "page" -------------

	err = runtime.BindQueryParameter("form", true, false, "page", ctx.QueryParams(), &params.Page)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter page: %s", err))
	}

	// ------------- Optional query parameter "size" -------------

	err = runtime.BindQueryParameter("form", true, false, "size", ctx.QueryParams(), &params.Size)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter size: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetErrorList(ctx, params)
	return err
}

// GetError converts echo context to params.
func (w *ServerInterfaceWrapper) GetError(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetError(ctx, id)
	return err
}

// GetOpenapi converts echo context to params.
func (w *ServerInterfaceWrapper) GetOpenapi(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetOpenapi(ctx)
	return err
}

// This is a simple interface which specifies echo.Route addition functions which
// are present on both echo.Echo and echo.Group, since we want to allow using
// either of them for path registration
type EchoRouter interface {
	CONNECT(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	DELETE(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	GET(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	HEAD(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	OPTIONS(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	PATCH(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	POST(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	PUT(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	TRACE(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
}

// RegisterHandlers adds each server route to the EchoRouter.
func RegisterHandlers(router EchoRouter, si ServerInterface) {
	RegisterHandlersWithBaseURL(router, si, "")
}

// Registers handlers, and prepends BaseURL to the paths, so that the paths
// can be served under a prefix.
func RegisterHandlersWithBaseURL(router EchoRouter, si ServerInterface, baseURL string) {

	wrapper := ServerInterfaceWrapper{
		Handler: si,
	}

	router.GET(baseURL+"/clones/:id", wrapper.GetCloneStatus)
	router.POST(baseURL+"/compose", wrapper.PostCompose)
	router.GET(baseURL+"/composes/", wrapper.GetComposeList)
	router.DELETE(baseURL+"/composes/delete/:id", wrapper.DeleteCompose)
	router.GET(baseURL+"/composes/:id", wrapper.GetComposeStatus)
	router.POST(baseURL+"/composes/:id/clone", wrapper.PostCloneCompose)
	router.GET(baseURL+"/composes/:id/logs", wrapper.GetComposeLogs)
	router.GET(baseURL+"/composes/:id/manifests", wrapper.GetComposeManifests)
	router.GET(baseURL+"/composes/:id/metadata", wrapper.GetComposeMetadata)
	router.GET(baseURL+"/errors", wrapper.GetErrorList)
	router.GET(baseURL+"/errors/:id", wrapper.GetError)
	router.GET(baseURL+"/openapi", wrapper.GetOpenapi)

}

// Base64 encoded, gzipped, json marshaled Swagger object
var swaggerSpec = []string{

	"H4sIAAAAAAAC/+x9eXPbuJL4V0FppyqTX3QftuyqqV1ZvuTblo/Yo5QfREIkLBJgAFCyPJvv/iscpEiJ",
	"upLMzJu3fn+8iUUcjQb6RHfjj5xF/YASRATP7f6RCyCDPhKImb8cJP9rI24xHAhMSW43dwUdBDCx0Wsu",
	"n0Ov0A88lGo+gl6Icru5Su7bt3wOyz5fQ8QmuXyOQF9+US3zOW65yIeyi5gE8ncuGCaO6sbxW8bcF6Hf",
	"RwzQAcAC+RxgAhC0XGAGTEITDRBDUy4vhEe1XQbPt+ijGrr10D1oV9seJagt0cfVRNC2sQQTeleMBogJ",
	"LAEZQI+jfC5I/PRHjiFHrWduonyOu5Ch5zEW7jO0LBqajTEry+3+nqtUa/XG1nZzp1yp5r7kcwoTmWOZ",
	"HyBjcKLWztDXEDNky2EMDF/iZrT/giwh++n13QUehfalQj3/7gXGgOdQWBgjLgqVXP6vXHY+xwkMuEvF",
	"s97tJEz+pBB9nYcqG2HZsK5CY1dAEWoqSSEK+jgNEfRxoWw1a+Xtndr2dqOx07Dr/SyMbYjimcXIefMr",
	"zkC39iNHIAj7HrY0CQ9g6Im4XZqkOwPAkQCCAvUZ/CpcBEwXoIj3Yx5A4FHi5AHtD0JuQYFscHdz1iOY",
	"A4ZEyAiyi6AjOECvAWZQDg187LgC9BHglBLEgHAhAQPKABUuYiBUa+sRAZmDBC/2SI9MYREsRHJa7lIm",
	"EJOzgcRkABK7R3B6QsyBhJ1DHwHI1VTy7+R0YDrbdIv6lHoIkh/f1PW2c9FRDJmXzYqTU8hGmeO/hQz9",
	"yHHBPnRQTKEzXF9ilA4UNjUekQ1UB7npwA+52ueQ4K+hFE2qoYNHiACGOA2ZhYDDaBgU1RbLSeRmUR8L",
	"eZIGjPqqi1wo4kLuO4PEpj6gBIE+5MgGlAAI7u46+wDzHnEQQUweQ72RKYaiAMuiWI9aUJjtTS/wzHyJ",
	"FhkwOsJykRH4zwr8PBi7iCHVRM0ij2fo2WrxEV4gkd0czAViCr5jOpYn2sNcAOh5IAKD7/aIK0TAd0sl",
	"m1q86GOLUU4HomhRv4RIIeQly8MlKPe2ZFjdf48wGv+mfipYHi54UCAu/gu+RbzwWU70HE/yQaFcQhz9",
	"JFFPqAA8QBYeYGTnARbyRxvZoZXakAV4mEW6JA8UyuOUzSiTfZefrvRxWQPds6Dc0tCC5MYMc6RmzBJ3",
	"YT8G4Rnb80B19iVIyWbfAUwdNexmv2oVYL9aL9TrlVphp2w1CluVaq28hZrlHVTNgk4gAolYApcEQjda",
	"DypzBAeY2GqvNYUqngGuKBPQW+csRudQ4BEq2JghS1A2KQ1CYkMfEQE9Pve14NJxQdCCnLqgQZ5BUsPa",
	"RoNGf6tQsWqDQt2G5QLcqlYL5X55q1yt7djb9vZKzjvF2Pzezp3AFfxzEX9Oc8h1WM4MkIkBskDY80IU",
	"MEzEhpzbokRATIzNkD4u7eibPh1cngLk9yX7JlLKukgeCugByMQAWlIJi/W6Xxga5HZz/1Wamiglo4SX",
	"4nGz9D0r5IL6+A3GcmjZUPGy2+lu32YUlQxF08ZcMDq/6lupwchvuB8q0hUUhBzFGoGljYYi6AyAhwYC",
	"ID8QE/XJpVz0iB4YjLHnKUri87Q9QDZlsFDbySJgdc54lulmDSWR6u8SrL6Ul1xAz0P2usg3o2jmloF/",
	"n9qhMcLS07cIgB42qlGgR+F5qVTJvbTVz31oDceQ2VxhCQrYxx4WE7X6TaDLAiyinTl8RbAsxNiP4ioL",
	"mhFiPFMbaAGO/BFiwLQARFm9qe3fLm4Xt8srSX41sbfniGUD0o/YLM5C3f70o8SexRAUsXYWUz3ehOyj",
	"ISdZ+BzYdFX/w/1L1RJnHs9D+fPPAjVGsBw1E1w524QL5Gfog1JXowMwbQN8qVsFFBORAPG7gDGTZoKU",
	"xTQOCOx7CBx2rrrApzbKNFwGmKEx9LwNIDEdIna1GAtTbrXZqhcyKMlksy2NNiUD7IQM8Zgbq4YZPBY7",
	"BEeSYRkUnaid8j0p9qFo7dlGI2ytsHaSHYDukAdWyBgiwpsASryJlA6D0IuFC7IdVODYDzylXBcilsWA",
	"XMKMFCnZaFTiNsxcYNRx5Qrjht/yuSFiBK08Bqe6lTGKPLSq/Zlu9S2fowEi3ILB2gftMkCk225daT7P",
	"hNoMTJxndZaT7okcDAUteCM/N+uj6CIPWQK4Uo3Vsn1o1N1IRMcjI7sIPkQDfdDfpexncAxC4iHOe0Qo",
	"nRkypOxLyoBPGUpROJbqPrZcYEGOpMocj3N2f14EH9TY0BvDCe+RkCMuf88DJE3esYsU4zJTEArQq2Aw",
	"OX4RfGBw/AGonhKyGHzeI1mDLIDTKCUk9JX7AY5z+ZzGX4zKL5kWWUA5XiQ3bhJfJdGPGRZI/qOEhFWa",
	"hH5R9S/apTSHNg6BCyqQRDEU8huPkCCUFgWgAP0QezYQ2EfF9bWK+DjF0GXKIOZyf9VQN8fd85TUVR2D",
	"1f2u5rtxxCRPWAl+N2on+3B3iCaL2S3nLhiiCV8XNd3u8SnKxIbE8RslK6n7Nmr3LZ8LuWY42bDJrz8i",
	"/+54lsnwbZmCpOR3ho6mrQwlolfpDPqczahOUMBse0lCHvF/NTrkIPCgHBm9ioXq/vxgSv7NjgSBg21J",
	"y9D4OIx8m8oERpUznBJ0Ocjt/j6vLse/YCKQIxH6RWv9WZdFiPmYSy2WAz1ALKgURJgAagmoxJcPRQqQ",
	"8la9nrXcAAo3S1MXLohtSi+9JsU6/In5fW7E7EN3OSb6rimNvzDCn+z1k9A3o7arFX5ZdSqn2mP6aPmY",
	"ZN+eyV+T6zGqJSagPxGIJ5dRrdS3683aVr2Zz70WHFowoISYiK26tvIiMZB2R5RGkK20SxKd8zG8KxY8",
	"VTCXWiizOr3uZgPLqHaad87dVlAm+GK+oz6DX6XZSpkADBIH8Y/K1xowKqhFPcWWpHaSROPvuWp1V1hB",
	"Lp9rls0/sA8D9c/NLrHW5PTRgpMcX/JW7UJah1lGIzypXpsxy1jZmjuUkt9xwRD0M5f7wil5FhB7VP2y",
	"AsRompPu5cVt3EmyBupha5LpubwKhaTe2OsMdFvQ2Y+YthTMQPJrngdcMhIoACQTrYQTS6pKsV8dCNoj",
	"8tw6ruCxFii1Hh8KbEHPm8gTR5ByaBu2JFfiYTlUNLmZ2aKEU8/oI4YT7ubCUHkP5/kfo5J6zSrnT86m",
	"WExgcJYPTWdaSpwJpWhu4/uQo5B56fM3ZReR19eySZEh24Xa42tpQViyMRcl5iKvWWqWXptbz1v1khyR",
	"8hLlpRS2GM70Zc/QEVLWbBJzKSvWQwudRE7gWC6yhtldncBRSlNylSuBWbCDPhLQw2SYjSkfM0YZL2oP",
	"YMCo3I4iZU4p6vffUkH+LfIQVnthuVzdgsxyf9MYXANtehIPczEPRAyD/Fy0EBGUq/n/myEPQY5+axY0",
	"qSdmhvL/t+r6FwXfHuTosrsOLMqf+OxSMcCv2Z4mLjeVA9USMiwmUr4JlNA31OVtdEoXXb8udhAyTOWw",
	"iY+x9Nb2zPPy48G5N0IMDyZZn2f99Cuo7c5oK5s46lZ4sp0sjqn1R2xH7mvJBxG0Iw0ispvzGRhZ5IBu",
	"6WtIOgBT4BP+HWjb+pJXalaCJtX76RFUzSvr0LpLs3w8t2aCDxzIBiC+K8oaMtNSkhaSDm+QhlJK++Pc",
	"LSC72mhUdkCr1Wq1axdvsF3xnvY7lYvbg4b8rXPBjk4P2Pkj/nR+fjcOj+FN68S/OaOdt5tB9et+1d5v",
	"vJX3bl9LW69ZMM1fAcnlVLJVZc7HlGVd5JmbZtMAcAGZkmTCBb9s/ZIHvzR+yUs995dq/5fYA9FHgAsq",
	"5R/kPQIJQMRik0DKuGikIrgULmJjnHBc9BEQyj6ytQo9NWd6JO6XpMlkYBDSSt/sjbmDCVAfzfHM1Ouz",
	"jrUkn+851eu61pNxYXvUVudnag0sE8gZcWXKtEr+coN4QImJOPO8NUa9VJDdoAFiiFhIWSAzN4t2+jhV",
	"qjVUb2xtF1Bzp1+oVO1aAdYbW4V6dWur0ajXy+VyebWisg5Xi1c3vfT8/kUta5+6WtXTanzuIw+JxPSb",
	"TRqN0rH/g/ZDL+nMyP71FqVaZ6wkYt9r3uqqmaNdWhHAqIdcvgbq8J+6MeoGXTkQMzU9A0LaZJYMhA2g",
	"hf74liWkhvQFr3SX0xes1pJ9pW8AWoqKc0jwAHHxU/HhJwf9cWTMOgni0ZevDAkYedN+1sKo1F/Rs0V9",
	"H4vMKJhfXcjdj5HUkDsggGme/44LZq0XYWJ5oS2V1ouD+5vWhpfMMSLWsNkT+LvRUW8rNUpChQ7tne7Q",
	"TKRFPtePY0i+fJvVQfvJ+JK1vLWbB3NkxHAk4jDSXFValYVm5s2Xoio2xcvS2y/ZOMLhbOf1ed/sMN/L",
	"JuaoKIWAxLb/DImbxR35WqJULXfK6JNd0YZIWyQuNM7WhEeibjrQen1SiLxXaQazyDcDpRe4nJ3p4Q6k",
	"fZ3hRUMCYuVLmfUepMxRyDPtvHkNIG48B4BejyQYc7vHQ8tCXK5lALEXMqlwB4hIbiUXlDCB4oZzhDUN",
	"25pb2ZLI37noqSimLI4TXRhyq+Pusu4YzTGeuuaiQaMItbRTXzn+2KRoflI+KjXrroBOpi3q8eepxT9/",
	"y8OoB27PukC1wQNsRX7peFIVgr7KV2AWmGmHREv6kbDsJdsS74ex7Kx0rN9MpAHlSkvJRBV0Mqx06Gw4",
	"g45EztR7V+EmwQs3CX5yjHiY9UbJ3yPNIFJi5uLXp4uhxMQe6zOWbQeb6PyZ243r/YvswPgZ3HwN4aSI",
	"acmfmCjtktmP3SVYm437z0dLzjxtSvKu4Qj+N/EDK1/dsxM42f46/Tly7GW3+SFXsnEsvfuK/3Rf8U9z",
	"83LuPf+oE/eHwi3TkdY/K1D6eXk4zoEKHkq2SYXvJi7UMAFpbb0Ibl3EUY+keiejmqW0tVHAqTdCJnNF",
	"MIxGKB6/CFoxgrxJXgVP8ennqVsSjkzyC/YDyhK3bv+aixv619Tn2yOG+0655np4nWV3GeidiY79WyJc",
	"17zxXSdEde2hVgeYLh2hc9XdJKI0uq6ei41adAfxbxVWmkzjeI82/cdGm6aDTKe+nkQgSEC5cBjim4V9",
	"vEes/ltErAZwIrXrv0VUKrJbW172SESal12ABUfeQKVUT/RghKpUWTiC2FNh/VFrHRXLKBWAsh6BZGIS",
	"lyWik25OFfEkDfyPCuZo4meOBAcDjDw7GnNuOZgD7BDKomymtdjtf0DAbSIhcGW/ZNsfCKFdX/ivHxK7",
	"f3F45YUOJlqczVt4SwyizPFiXWdxeG2sqH1PjC0iPGToOYAsqm+yvBTBgWoPothxoDuChB4H0CtOWsvJ",
	"AKA1gnCnq9GRuHEArgnIxfbfEok7BWtpOO52o/F94bjJCIu5mFwbs+8MyZ3BZhyOa6JzfwYy143Ljd21",
	"P8uXbpk9nM85TXqAZQ+YyCHPyLRYzxVs6bwu03xm4Gx3tVry33BJrFH9I5fD0kbaMIq4s39pFGJASZ9C",
	"tiqe2MbP/sB51uh+lkA8+9B6lqxqwb7ikDwHYf95iCbPLuTu6laYcGSFbI3x5Nl/tpAJcZ53mkASSh4a",
	"KmCliEPseWE5kLnDryy2zRDa1ZHncU4h4EioSgkLBcoqzq0DAFX9lZmxc/m1pNE/IM/jT5RnK24d3nNM",
	"/u/kmKxILXn+p+WWPC9MLsl2Hb0nmGyYYPJtCWq7iVG/C6sRWOpeVmeiUwZsHfGdIXZ5QmJkZjcmxpuO",
	"ksCnQB5BYjPcpeTUqll14/SkAyE3johgw4J+C/H+FKX8bID0PUxsAOMIbYLEmLIh0FfMOj4bSBtT/osh",
	"CZUlgGBwMMCWuovvEeFSjuIeceUsJZaREJg4sciTI2UJzGwPKkm4KWXPPMBztVOiaZWjAwaBN1FZOsl6",
	"ctNJF4QKLCHRaPhItihzO7Fb6V69sFyuWbqP+jf6vaR/8yEf6l++/K/+5bzV1j/8Lw44Erv6V/Vv/fvq",
	"C82ss3DUvvqRq/9+aA2RWOwxhkRrD1Ledm9bF/utm33QFZRBBwHLg5yDPTVEcbZCmvmjYGZYGIGVfRRu",
	"XaTNvJm4kPjeRzJNVaPRBm3qB6FA4IA4mJhLnmKP3MblqtRAMwXkxli4Rr87al8Bc2uaN/5NzJUnLu1n",
	"U2OZEn/TOyhV4CdV6iyuLNcjH0wVIFaAAS7oLQ9DbOsd/xBpMmY6qRaIFNSbVJ6blhWcR6Vcov6eqOUV",
	"rynyFicv1RL4lVRv8KlKNcaohPJvbKvRo8JvRdBFCMQX/R4N7aJDqWPCabg+Oqr+VymuH2dK9qXrxanA",
	"itATuGAgj2vLWR7liItISTP0R341Zd2i46kPZtzto0SzJXkXSefwzSIZhRsUL81mIwYvat0gai7hVaOk",
	"T3LW8VXHs9gjB9Byo0OisG5uhxM5jrFiaaZRdzJFcK8g0MowB5Ch3R4BoAA+SGVz9w/kQ+xh+9uHXdAi",
	"QP0FoG0zxLk2JRgKGOLKfInnsuQQYGZZRXBIGTDYy4MP0MMW+p9ECNWHopnZyMeW7rchDHpqM8Siuf1J",
	"QfmzCzAI/gcGAQ+oKDqmU9QnCZKyXDbFhll/VKVQwjWDAtvHhGfiwKY+xGT3D/1fOaEiT9ANsUBA/wp+",
	"DRj2IZt8nJ/c8/SEUQKVkbRQmL6zGJmS3gepUn2YgSmb6pYfzaiyo2YOKpcIkkmPRPjtzeiu6sDNnYpc",
	"rIxG52HdzcsZO3V3Hs25fM4gOPnjn1I+OZa7P6+Sn5LNcvzn2dwQyC1EbEhEoc8gtgu1cq1Rqa00khLD",
	"5VcVBjyKTP8NlIflCYWGLWnnwNSp8isN9PAfM5MKVxeHnRnw+8ujdRLX7Rto0FG3Fbagii+1tb2wzmX+",
	"QdReh0Vw0adUrNv5MO6QqSTOzbFxSJK5ClrlYFbtluH6MLmyDUDIjIy8YnSEub43B3c3Z2sFOGZCl4zL",
	"3wwwyCwXC2QJ46OdEm0cWrdA8dU/rxH7fjsJ9B2jTlhZGabQvZWtMkow/YSr2KlfyPgky3NeX+MjUovM",
	"x76hInhwEYkqb5eTxWRlBywFq48J9kO/R2w0ULUi+5NEO6XXpIVLvbpT39naru5sLXIyaXX9mQZrZZak",
	"Lalpd1PQO1u3lnMqddlMomwVpbgGHpotCQ6URic3AuhF8h6BgKMAMskcTWsbSYtLK7tKwGLBAR2TaIoi",
	"ODfj94iNB+qGSURzSCtijKR1zKdgRN8MD1Xly4fKFcBQj/Aw0BJ/gyt7jatbNe5KQZqikhQBzJzSLxE1",
	"LhKrKLqEWztpI75L2jhpxaR7xMdgvQHSWagznTcgxNlxliI4SjpJo2+j/I58TkV+6H9qoPW/o4IoJglk",
	"jp0lmFRiKjiW08AxL7iwwNwQm78S/+QwiP9808DomuMIBtupL+k/Ev1UaFqckmf+iqJhzQ/TqLN8zlHO",
	"U8eKB3Akz481MvXfVAdMRUHKK9j30kPLD/HE+o/0x9lRGBxP56EiM6Aul895eJSGQHFF6BV0HBO1JNQj",
	"HkgzfvqvAh3BXD435t6CLZL0fWpql6Qpaj6M9DvcUJ1kZF96fB7atECoKgFgbxYOHxIoBCL2+uEmp3Gs",
	"4CYyPJA0kHEvqH6X1rMT+shY8CpEilKhEjEY0MGJKitUygAPk/QtDqHcF78NKLPQsjIPi9VdM0Fc/2A6",
	"tP5SsFE/dNbLiDk1+YXfkRs0nfZQpxG0PRrahT3IFzijVOB/ume1XC2Xd8rbxXKmg0VdSWenOAzpC87I",
	"b5A/u2F/ncwQyIezZlW9mmWAJCo2T+GorX6Xw4A/ncps7nTEKVa+LNibKJV91pKUxGvSAYlKVZ6LhCCa",
	"DemWi4ZfJFMV318HO1lnKooOSQ8pdYsFVbgdtCDzwqiW818EFdDL+jSDBTVpPn54Sr/3pDvnFwaL5NXD",
	"HN6PONFVwPEzhyO0+rr+1sU89vdiaUT6/ZSqpz2ze3eds/3ns8t266zbuj8AiIwwo0S/gNAjI8iwviaL",
	"7l3k4Utcn3E4kkZRohC98oN63qQIJAjqVR2pqNpohDwayIGVo50Sb5LX7m3t55lGkWoWxBa8azOzFwmc",
	"LMQ52tDy1p1W2N1DNFGxO/NctSsVYM1SdRPgwQkN07ECYWZOqweJE2bn9kcuXx11PldDPm8uy5lsRRDo",
	"I4v6iAPj4sur5z+k5UnUd+WqBRxZlNjQpAkmfGmIPN91i3e3h4Xmj14iXrY7m535xSP8KY8NGTN294+M",
	"/ChERKZDoKWecFJXOOrukCORj4lNnvYBEpYrCcOMUgQdqYQh4+b9V8i8f8kO0kw1ZlS+R/SdUCqlSdl4",
	"phSDopkFF446GicjNggSORbCKvwamqoS4Fez17ugXN0q1/tVG26hnUa9b9fq/Wa/WYXNWgM14Pa2Xe1v",
	"lQcD+DGvY0j6DBLLLXh4iACLE5+n4zEXedOsSqkXf5y59phvkS3YB/MVFtboZkK4lzPHfSQQ86VVDMYu",
	"MqjRdympV3J8SKCDGPjVgsT2UIDJR4BtRAQWE/2Clz5f6moYKpNnrjocaFPCQx8xYMnDpZKzZxPXIAeW",
	"hyVpptu4iPRIfJbicyC5ZnSwFhSfWz/gbjZ8dI4QXLMV8+6lbMm7QCRn1QswglTNkEmbCyuAvpf4/AeW",
	"+MzehkxDMQqZ22wxi8HJT0ddBtkSqLhKgkIbW5bf0y+LTqPHX35ayYXoeThTM0jQSJkogkPsIeB4tN83",
	"UQOx4y7fI8gpgg8ql427hf/3YYa7Cz/MrDO48IGaS3NNEz9QswSu6ImjvgfJULbqEV1yIKE9RsOk3jsC",
	"D9izLfUSkNJ7ouWY1dSLlUpxbim1Yg1+/61P6mGjn7FpqfeW5sM4IYFKmSsISj3+w3AnC2HN30RknmEU",
	"0AVfFubIJ8z3eTsdO77dWPSJQLEoWj268Fh2Ble8wKY9xgvt6rxGQgzjF4m30Au0LvlDcVKQo+xw4T3z",
	"RVtTcR0mY3xNFY7csjcyJkteyFBZUdqy10+NqlugSGNUBVQX+FKeTQyDYt5LHSQzeI5Xm3kQZxC6SPtX",
	"dTXWMgHillnTqcS+BbloNhk8Bypbja+Rc3cOSZzdxs2Qs880Gs1yvdGiMb4tAns25HjRterKxMZlE12t",
	"mkefneeocvXyy4/YT5w92XoHNmWhF3ukJYAkUG0BGznywZSK+ZAHH6bVQ9RfpmrJBzBdh4p+6pE+mip+",
	"Suyo1F89oq9FSDqUhTJbR0gFDFnIVkYR1rnO8Ru+cl6p7PfpKDNYNVHT5q8rZbNx6Zr1cmecwDHVqNKP",
	"0U45UWzOLLBgpmVtZuI+ro7AEE3iDGYpC6ZZ0UpBThtgKSlZkP/bOzjqXICroytwdbd31mmD04NHsHd2",
	"2T5Vn3ukR/zrzsXeUcvqWnTvoLV/Nmg+Hg/R28kWtL3zx/E2PDrqeCfQE82Tl+praa96+sntDDrh65EI",
	"7l+2UY+c3Tj7d9tbL/C2EdzvN/zD85NaMEQE3ZSsW//r1+vhxeSau5+r9Prz+ODtrtuvtC/O24P2kTP8",
	"3Lyu9sjb05B1rDY7LF9Xx+y078HQdu8+4XtIWvvcrzQfD77yfqN1V9u2xR07r10/2g/Ozs2nz/hqcN+8",
	"6ZHTvZfbcm10v3dpn3f5Y23nDLbJVieoXI6CZueAljro4P6x8tVvX1614Gm5f3JcCwdOvR2iIf902+2R",
	"8fXDLWqfvYZPZ1uX55/p5dXpeHR+PXjtO5XP+81R+FQ+FS8l6+K4+grD8qvPW+HO8UmAhqPLq5tXr0cm",
	"X8XL5GnA6D1Gh5Ng/OSMrseCkPNmyekehKWT+1v2WG5U/YO72+221d+uD63jw9vDwfnQI8OjUo+UB3f1",
	"1g1slOvHtdeX8lD0UW10al19pleX4enePT/ujsrlu6PH1uQKhZNPzW3rrvR44J5vD2vd+9OXHtlCnSdn",
	"gs8vy2Ov8ni0f3Nqhd54yHdan0Jv6FTobb/Oa2/+0+iqvH1Eb18f6tUXeNp46H66cJ8Q6pHmVvkzvXf7",
	"VuU06H56GTzRF84OxFPzqn/39OlxdNi8CZj90GIvx/2TYfUkuDltvd66r/y6xffco0qPlM/C1+oDPN8r",
	"O9VO48o6t09K1tcXWm5aFnvZ+xzi1weGGzjcOf8cNL/elgbdtwuf2x2HNEtfn057BDevQ28Qbm+HX92H",
	"0lhU+4Jg4dzwry/u63n48nhXf+rX3aE4bLqnd6XPn7fr1a/uWeN03LppXbf2ekTsHx49PdyMLP/AOd0/",
	"r5x2W80n/37Yr524Z7fnlbPPexP4UHEt4rWi363jkxH071/sdmPUI5ZvfcLXJ5d7e+d77VarfogPDtDx",
	"ls/cw+Pt8J5fn52fV8uPDevJJa+PzcOWr2iofTRuHrbHw06P7I07R4fX9KTd4u29vcd2a3zQPnYO2of1",
	"VqvtDK+nvT9dPLZK23uPgeNNuq2nx2P3ZXLq9kjp02Dr7WpwP+ofV8sHX2vDzvbl4d5FmZx9/rR3V/HD",
	"UffT19uwW3s4Y3s1v3YUeiI4vTk4OT0TfuNgv0cq7Ojtc4veVibBzmOnedbat8/b7cvJS+uF04e75vbj",
	"Xdj+VOqTF3aLbqpnN5ftweSqvb31sNNs4Mv7HvEb3U99fr0/3m5Xz5hnt87r5/shnTxVulgcwaf66fXZ",
	"vfh0ewArdcwfu0ftlze6ffXYvK+dXA4b5R5xvj44zepFqe9XD96627fN2sPBfr/ijV7qHW/06nS+niKn",
	"Unn7/Pjqs8fu08lJezB6G3zyLrpb4atz3CMvr6WT8sR7qp7h/hHbOmq1Jpc7dw+s9dQdd8/LB9bLbXN8",
	"0Cavw+5+OPnqP4zvRxd7n8ODzn3zEtUee+Qc31UGJxdNbm/vB/zwtXH+6bNNzsl199Mxe7m9Ot2v+Q/M",
	"a9nk4Na1H++bL0/D4MHdn/BaaWcHXfaIOyyzMzIpv1yMhzAclPBd89La+jw6H76c3ZyfOI27nfvTyUn4",
	"8CDexp/Jy/lF4+HmcO/raZ0/Uf/8vEcGon97XPnUmPRvHkqt2mivD19vHqpi++7t4sV6Q8Pu0wGGZxc7",
	"Z6Vj66TdualcHza3mtV9u+UdHO7YPTKsOtf4sXvdgvCkfHLSejse3QxvTs7OnNPq4/UjPr64n1RF7WRy",
	"OOAM+o1xt/1wOXCvUGdytnf7dNIjIxZceFd9NOC3O43t20F176ITOm9PrN24f93vng6fnBu3cn806nau",
	"SXvyNryebB3cVb9eBfihsSN5lHvV+fzETql1Wjs96+6U8NvJ9e2NJ17OW7/1yG9Xg9vtHlHS5eBif5no",
	"WVCvhzL0zLmXLaTfy7atfuJjqTv4Zz35kSxfkul1keNFjg1d40Q51RNaEeRSoeFAmVyJkHhVOqVHfg1w",
	"gDxM0MfMMipzQdFRnUy6Yamgn+tHT7vKwQJP+Zq51eaJwM3s6kxVsmXb8UVd5HM1j3nAULiU4TdkK3tm",
	"PkF3rbc5Wt0HLIaXx/W75nb9wOZ7d2Qi+rX+eHTjOMfetdd//Oxtk0p5tLOgUGdmnu+dftEkNn90ood5",
	"alEeqbRjyPYxWR2yylVQgcRTlnW8durlT0ihBP1J4uWMjPKeUTU3O5sTkY7uUvkpuZUroSEDFbTFNwbG",
	"h3y4Liyy7UpIdLbppljJpLGk32He47JGnSQ9QtKpoJmKhZiwN+gsmy9zSyzwt8zBHDBqh3HKw9KqiTOV",
	"ib7TdTM3zGLoZxc673INBX02JX3hzLtLy3nl7C7sZry6oEvMB5RvMGqqBtUMsJbAI13vxXDdVFIKRxZD",
	"oqDfOopFefy2UMbZ7UOOnjMdI/N+kTXUg+gWLjXcokoVlDmQJDxeySCzerlWrWdfQlurZWd87zHwoBOl",
	"nzLX0gnR+t4wUYIkyhiFHqem9J1hUBx0zIpmpP+iNaVrsiRrrU+3tShpNYHYlXidEScpvOVnz0QKhsQG",
	"JzYnSwjdJuqXbRDOE3VbEdBDRKChWhJ8Q0QAokYpPatcJJQJtwB9xLAFiwGlXpGIQOq5uXyusuzzRopZ",
	"sobb4ku9qFU+EhhKiNzdtlOawV23dADlOSPrhXXOX2yQydovUc3mPKzs061t1mUuQ33lHG8hQ5t1WVAG",
	"f1W3jMi/VV3mwqZWdVh0//TtSzbniWwPB48QyUgIUZnYmAPu0tCzAUMqRqGvimFeDkA/FGB+k3R+jQo1",
	"k/TSIxl7rwMDgY8gMeFQ0PNARkOgTx7vEciQZnzatpibF8ZtDZccYaouhrVvXgLcIyz0kC6NydCAMpQH",
	"YwRcOIpz/9VpBiptXa6ujwAcw6jkERYAc/JB9EhAOccmTtHHryoax4fCcvUlgdkPIKijLCLJlGPaWXSH",
	"lcgb2uR1t5nUjbVJas0es7mnGxDUmj2yn05YmzbWbL/gJlFVgdo81ybO1lknsc5kL+nMukXvuZjr5ugQ",
	"fJk5Lhtm17CQkEUpNKlkqrlTuPGCfjDvLfvWfWbILwsF0eJUoCKvxTk4UcZPMm2GWrhoGIau4SARGHpB",
	"0WQ+mtrO2Sjc/MHUafHwH3qBdE6bfn8f9MfeB13D+lgvakYp1VbIsJh05VHX276HINNnpa/+dRhNd/Jw",
	"K1Vg1VKq5rpdPKq0bHLfvilTZUCz4st1cQpBjfNPRdHrGCmdw8qLKsHLQuZtT72JuVYALReBqsqLUep/",
	"7CQej8dFqD4rz6zpy0tnnfbBRfegUC2Wi67wPa2CCnUQLrt7anqTBcmAqsICYIATQTO7uWpU+1x+2M3V",
	"iuViJaeL4ik0lSyPEsRLf2D7m6KWrDpBR0gHpWieqSoGAcPo5LlRkZJIRA/W6MecYJSSEKky+kW8hLOS",
	"MpV6MM39Van+mBKgWCyykV1MFjDt2BqU5CujKvYa+kgow+H3jNf9oiTlCHhBgaMqFWGizp5wo1ij3egZ",
	"rejEaRNOs88/5RnPL3I2/Qis2oxquZwIfjdJa565xC+9mPqvU4CWCvcEltRxTmMmiRN5ROo/cWqTizs/",
	"aYdoFTJKVsG2nrry50/dClW9xyFS/nCsAdGz1/782e/I1KUtT2CAmDwbID7bGpL6XwHJkNAxmdmCxl+x",
	"+3cEvQY6xFrldwNqqRcp7BQLV1QcMe/fv0ga4aHvQzYxmfhJJqSYV3ye1Dil6A9VqTHrVa+2LlECAUHj",
	"qGseBFQuHUex4NyUQ1Oe4BFiMGLuit8bgw1BKyoiilnSfOPzjOuKchE9Ba2ZDOIielT651B8+hHQb2nx",
	"KZnZtzl+U/nZs3fsrK03H4ELuVY/kP23MR02fZnznfO8c541OY9hGlmchpdWKk5RIc6oh3KETIAPlU8n",
	"1p/y8dN/+R4xmZz6OSyln0t7c5FOlHjp+89UKhLTZOB5dpnvNPZOYxtK9/kjlKI0W73xH1sr+s+MhzvV",
	"71MbRAltaaBJa0A9cWSjABEbEQFeaD9DXOsRpgJ7DTMjmks97KPg+s83MvSSNbIWGxsRZjRa3q2Od770",
	"j+JLs9xkhif9HNfJBt6SCIsr3CSpx+E34mD/11wlKUwt4V/vjOudcf2j3SUL+Zd2Ayd9JhneC9lkI40o",
	"waz+jbjIn+B5SWBGDfxX+14S89+YSbKOlKq3j8bTEs99pMqk6AubbL4m0KsoqVucNDyzqF2be9V/1gRZ",
	"tPktZbNLtKQeN1hCAJ6pyvU9UnyACeZuQoiDpTIci6nozhvThFOVkgcw0WcYUwJgn4bCJO7x0BNLLX8J",
	"/ruQX+26kHhaQBryCMRvUOjInNg9jAkgVD9Va4UeZKboPvhVuDR0XBMbc9K9vPhY/I8jpCP1wIITBS1F",
	"pzyLjHxI8ABxsZqW4pZrkNMNEiEjXGUWR/0UMMoDb9gZMaSi+LupwRs3tqgirLi4o9m+qAYxFCB5GUu5",
	"utvVeTqQlMzfhWi4YmMJKZ7HKHinx5X0OEXWAqJMbfccYf5n0lqaPNYgukS5kOU0FxczkyQ3R2f6+Rf0",
	"Ci2REkRMkR+ygfaa8aggoaG1+OJfFe9eRhkRnO+EsZowIlwtootoKzehi3cj9d1I/XczUud4Uxa/U4Mn",
	"dYo5FjN9xHiOuWStbNqkpCrJLopiTbRTpWb/VNKfriHrtMd3IwYZ72T295CZPuj/PCKbvgcJPQ/EgfTR",
	"aZqS2WqPNiRxncXIz6MhmxZs7E+AEp3ZhLq+/wiZ5j8k9Wt/sQxfuJXqA0j+9k7F71S8CRWj+RMkKTcO",
	"8V0sIS9Nkx8897PR13MLNaAoXiCtcjlE9GD3P1AvWbqcb3FGZxYXOzfv/KnkZ/U4Zfx+QDoAHAa4qIp6",
	"unigU2lhgEv6nRLleUCsED0yWhpVlbYyE5YuoIOJs2wCLqCDfnAahUQSvUMYT7NqnC/f/n8AAAD//0pt",
	"n22fygAA",
}

// GetSwagger returns the content of the embedded swagger specification file
// or error if failed to decode
func decodeSpec() ([]byte, error) {
	zipped, err := base64.StdEncoding.DecodeString(strings.Join(swaggerSpec, ""))
	if err != nil {
		return nil, fmt.Errorf("error base64 decoding spec: %s", err)
	}
	zr, err := gzip.NewReader(bytes.NewReader(zipped))
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}
	var buf bytes.Buffer
	_, err = buf.ReadFrom(zr)
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}

	return buf.Bytes(), nil
}

var rawSpec = decodeSpecCached()

// a naive cached of a decoded swagger spec
func decodeSpecCached() func() ([]byte, error) {
	data, err := decodeSpec()
	return func() ([]byte, error) {
		return data, err
	}
}

// Constructs a synthetic filesystem for resolving external references when loading openapi specifications.
func PathToRawSpec(pathToFile string) map[string]func() ([]byte, error) {
	var res = make(map[string]func() ([]byte, error))
	if len(pathToFile) > 0 {
		res[pathToFile] = rawSpec
	}

	return res
}

// GetSwagger returns the Swagger specification corresponding to the generated code
// in this file. The external references of Swagger specification are resolved.
// The logic of resolving external references is tightly connected to "import-mapping" feature.
// Externally referenced files must be embedded in the corresponding golang packages.
// Urls can be supported but this task was out of the scope.
func GetSwagger() (swagger *openapi3.T, err error) {
	var resolvePath = PathToRawSpec("")

	loader := openapi3.NewLoader()
	loader.IsExternalRefsAllowed = true
	loader.ReadFromURIFunc = func(loader *openapi3.Loader, url *url.URL) ([]byte, error) {
		var pathToFile = url.String()
		pathToFile = path.Clean(pathToFile)
		getSpec, ok := resolvePath[pathToFile]
		if !ok {
			err1 := fmt.Errorf("path not found: %s", pathToFile)
			return nil, err1
		}
		return getSpec()
	}
	var specData []byte
	specData, err = rawSpec()
	if err != nil {
		return
	}
	swagger, err = loader.LoadFromData(specData)
	if err != nil {
		return
	}
	return
}
